if ~defined WSOCK32_INC
define WSOCK32_INC 1

import wsock32,\
    __WSAFDIsSet,'__WSAFDIsSet',\
    accept,'accept',\
    AcceptEx,'AcceptEx',\
    bind,'bind',\
    closesocket,'closesocket',\
    connect,'connect',\
    dn_expand,'dn_expand',\
    EnumProtocolsA,'EnumProtocolsA',\
    EnumProtocolsW,'EnumProtocolsW',\
    GetAcceptExSockaddrs,'GetAcceptExSockaddrs',\
    GetAddressByNameA,'GetAddressByNameA',\
    GetAddressByNameW,'GetAddressByNameW',\
    gethostbyaddr,'gethostbyaddr',\
    gethostbyname,'gethostbyname',\
    gethostname,'gethostname',\
    GetNameByTypeA,'GetNameByTypeA',\
    GetNameByTypeW,'GetNameByTypeW',\
    getnetbyname,'getnetbyname',\
    getpeername,'getpeername',\
    getprotobyname,'getprotobyname',\
    getprotobynumber,'getprotobynumber',\
    getservbyname,'getservbyname',\
    getservbyport,'getservbyport',\
    GetServiceA,'GetServiceA',\
    GetServiceW,'GetServiceW',\
    getsockname,'getsockname',\
    getsockopt,'getsockopt',\
    GetTypeByNameA,'GetTypeByNameA',\
    GetTypeByNameW,'GetTypeByNameW',\
    htonl,'htonl',\
    htons,'htons',\
    inet_addr,'inet_addr',\
    inet_network,'inet_network',\
    inet_ntoa,'inet_ntoa',\
    ioctlsocket,'ioctlsocket',\
    listen,'listen',\
    MigrateWinsockConfiguration,'MigrateWinsockConfiguration',\
    NPLoadNameSpaces,'NPLoadNameSpaces',\
    ntohl,'ntohl',\
    ntohs,'ntohs',\
    rcmd,'rcmd',\
    recv,'recv',\
    recvfrom,'recvfrom',\
    rexec,'rexec',\
    rresvport,'rresvport',\
    s_perror,'s_perror',\
    select,'select',\
    send,'send',\
    sendto,'sendto',\
    sethostname,'sethostname',\
    SetServiceA,'SetServiceA',\
    SetServiceW,'SetServiceW',\
    setsockopt,'setsockopt',\
    shutdown,'shutdown',\
    socket,'socket',\
    TransmitFile,'TransmitFile',\
    WEP,'WEP',\
    WSAAsyncGetHostByAddr,'WSAAsyncGetHostByAddr',\
    WSAAsyncGetHostByName,'WSAAsyncGetHostByName',\
    WSAAsyncGetProtoByName,'WSAAsyncGetProtoByName',\
    WSAAsyncGetProtoByNumber,'WSAAsyncGetProtoByNumber',\
    WSAAsyncGetServByName,'WSAAsyncGetServByName',\
    WSAAsyncGetServByPort,'WSAAsyncGetServByPort',\
    WSAAsyncSelect,'WSAAsyncSelect',\
    WSACancelAsyncRequest,'WSACancelAsyncRequest',\
    WSACancelBlockingCall,'WSACancelBlockingCall',\
    WSACleanup,'WSACleanup',\
    WSAGetLastError,'WSAGetLastError',\
    WSAIsBlocking,'WSAIsBlocking',\
    WSARecvEx,'WSARecvEx',\
    WSASetBlockingHook,'WSASetBlockingHook',\
    WSASetLastError,'WSASetLastError',\
    WSAStartup,'WSAStartup',\
    WSAUnhookBlockingHook,'WSAUnhookBlockingHook'

if defined APP_UNICODE
    EnumProtocols equ EnumProtocolsW
    GetAddressByName equ GetAddressByNameW
    GetNameByType equ GetNameByTypeW
    GetService equ GetServiceW
    GetTypeByName equ GetTypeByNameW
    SetService equ SetServiceW
else
    EnumProtocols equ EnumProtocolsA
    GetAddressByName equ GetAddressByNameA
    GetNameByType equ GetNameByTypeA
    GetService equ GetServiceA
    GetTypeByName equ GetTypeByNameA
    SetService equ SetServiceA
end if

end if ;WSOCK32_INC
